#include <stdlib.h>
#include <time.h>
#include <FL/Fl_File_Chooser.H>
#include <FL/fl_ask.H>
#include <Fl/Fl_Pixmap.H>

typedef struct listrec{
	struct listrec *prev,*next;
	char name[PATH_MAX];
} listrec;

struct listrec *root,*last;
	int fuel=0;

char def_src_dir[PATH_MAX];
char def_dst_dir[PATH_MAX];
int abbruch=0;


int run();


#ifdef WIN32
#include "win.cpp"
#else
#include "lin.cpp"
#define linux 1
#endif

/* backslashes in slashes umwandeln,
 * evtl abschließenden slash entfernen */
int cleanPath(char* path)
{
	char *cp;
	cp=path;
	while(cp=strchr(cp,'\\')) *cp='/';
	if(!strlen(path)) return 0;
	if(path[strlen(path)-1]=='/') path[strlen(path)-1]=0;
	return 0;
}

#include "ui.cxx"

UserInterface *ui;

int srchDir(const char* rootpath)
{
	DIR *dir;
	char path[PATH_MAX];
	struct dirent *de;
	struct listrec *act,*prev,*next;
	struct stat st;
	dir=opendir(rootpath);
	if(!dir) return -1;
	while(de=readdir(dir)){
		if(de->d_name[0]!='.'){
			sprintf(path,"%s/%s",rootpath,de->d_name);
			stat(path,&st);
			if(S_ISDIR(st.st_mode)){
				srchDir(path);
			}
			if(S_ISREG(st.st_mode)){
			next=(listrec*)calloc(1,sizeof(listrec));
			strcpy(next->name,path);
			if(root){
				last->next=next;
				next->prev=last;
			}
			else{
				root=next;
			}
			last=next;
			fuel++;
			}
		}
	}
	closedir(dir);
}


int outList()
{
	FILE *s,*d;
	char buf[0x10000],*cp;
	int r,los,max,rest,full=0;
	unsigned long long int ll;
	struct listrec *act,*prev,*next;
	char src[PATH_MAX],dst[PATH_MAX],dst_path[PATH_MAX];

	max=fuel;
	ui->progress->minimum(0);
	ui->progress->maximum(fuel);
	strcpy(dst_path,ui->dest->value());
	cleanPath(dst_path);
	while(fuel){
		ll=rand();
		ll=ll*fuel;
		los=ll/RAND_MAX;

		act=root;
		while(act&&los){
			act=act->next;
			los--;
		}
		if(act){
		strcpy(src,act->name);
		cp=strrchr(src,'/');
		if(!cp) return -1;
		cp++;
		rest=df(ui->dest->value());
		if(ui->btn_number->value())
			sprintf(dst,"%s/%04d-%s",dst_path,max-fuel,cp);
		else
			sprintf(dst,"%s/%s",dst_path,cp);
		ui->out_src->value(src);
		ui->progress->value(max-fuel);
		if (rest<atoi(ui->min_free->value()))full=1;
		if((full)||(abbruch)){
			ui->status->value("Zielmedium voll.");
			if(abbruch) ui->status->value("Abbruch durch Nutzer.");
			ui->out_dst->value("Liste wird geleert!");
			Fl::check();                           // give fltk some cpu to update the screen
		}
		else{
			sprintf(buf,"wird kopiert, %d von %d, Restkapazität auf Zielmedium: %d%%",max-fuel,max,rest);
			ui->status->value(buf);
			ui->out_dst->value(dst);
			Fl::check();                           // give fltk some cpu to update the screen
			s=fopen(src,"rb");
			if(!s) return -1;
			d=fopen(dst,"wb");
			if(!d) return -1;
			while(!feof(s)){
				r=fread(buf,1,0x10000,s);
				fwrite(buf,1,r,d);
			}
			fclose(s);
			fclose(d);
		}
		next=act->next;
		prev=act->prev;
		if(next) next->prev=prev;
		if(prev) prev->next=next;
		else root=next;
		}
		fuel--;
	}
	return 0;
}

int run()
{
	int c;
	ui->progress->show();
	ui->out_src->show();
	ui->out_dst->show();
	ui->btn_run->label("Abbruch");
	abbruch=0;
	srand(time(0));
	root=0;
	ui->status->value("Liste wird vorbereitet.");
	Fl::check();                           // give fltk some cpu to update the screen
	for(c=0;c<ui->browser->size();c++){
		srchDir(ui->browser->text(c+1));
	}
	outList();
	ui->status->value("Fertig!");
	ui->progress->hide();
	ui->out_src->hide();
	ui->out_dst->hide();
	ui->btn_run->label("nochmal");
}

int main(int argc, char** argv)
{
	init();
	ui=new UserInterface();
	ui->browser->type(FL_MULTI_BROWSER);
	ui->progress->hide();
	ui->out_src->hide();
	ui->out_dst->hide();
	ui->btn_number->value(1);
	ui->min_free->value("10");
#ifdef linux
	ui->win->default_icon(&img_icon);
#endif
	ui->win->show();
	return Fl::run();
}
